;SCALAR.M
lv=0
;...
;PLOTSETC.M
restore,'colors.idl' & tvlct,red,green,blue
set_plot,'ps',/copy
device,/close
device,xoffset=1,yoffset=3,xsize=20,ysize=20,/portrait,/color
;END PLOTSETC.M

;...
;RDKRDSC.M
string=''
krname='krdfile'

;...open input file for reading
openr,lu,krname,/get_lun

;...read observed XXOBS,YXOB,UXOBS,VXOBS
readf,lu,xxobs,yxobs,uxobs,vxobs

; ... ignore next three lines
readf,lu,string & readf,lu,string & readf,lu,string
name=strcompress(string)

;...read mesh and variable information
readf,lu,iz,mesha,meshb,iz,lvprogo & mesha=fix(mesha) & meshb=fix(meshb)
lvprogo=fix(lvprogo) & lvid=intarr(5)
readf,lu,lvid,levelzo & levelzo=fix(levelzo)
lvid=lvid(0:lvprogo-1)
readf,lu,string

;...allocate storage for nesting information.
mxsh=intarr(meshb) & nxsh=mxsh & m1sbsh=mxsh & n1sbsh=nxsh
mxxsbsh=m1sbsh & nxxsbsh=n1sbsh & dxsh=fltarr(meshb) & dysh=dxsh
x1sh=dxsh & y1sh=dxsh & xxsh=dxsh & yxsh=dxsh

;...read nesting information
for m=mesha-1,meshb-1 do begin $
readf,lu,mx,nx & readf,lu,iz,iz,m1sb,n1sb,mxxsb,nxxsb &$
readf,lu,dx,dy,xm1,yn1,xmxx,ynxx & mxsh(m)=mx & nxsh(m)=nx &$
m1sbsh(m)=m1sb & n1sbsh(m)=n1sb & mxxsbsh(m)=mxxsb & nxxsbsh(m)=nxxsb &$
dxsh(m)=dx & dysh(m)=dy & x1sh(m)=xm1 & y1sh(m)=yn1 & xxsh(m)=xmxx & yxsh(m)=ynxx &endfor

;...allocate storage for amplitude arrays
mxmax=max(mxsh) & nxmax=max(nxsh) & mnox=(mxmax+3)*(nxmax+3)
ampl=fltarr(mnox,meshb,lvprogo) & zampl=complexarr(mnox,meshb)

;...read map projection information
readf,lu,string 
tag=strcompress(string,/remove_all) & tag=strmid(tag,7,10)
readf,lu,geo,gglo,gglo,elo

;...read amplitudes for all meshes
for m=mesha-1,meshb-1 do begin readf,lu,string &$
for k=0,lvprogo-1 do begin readf,lu,mx,nx,nval,mesh & amp=fltarr(nval) & zamp=complexarr(nval) &$
if lvid(k) eq 4 then begin readf,lu,zamp & zampl(0:nval-1,m)=zamp &$
ampl(0:nval-1,m,k)=float(zamp) & ampl(0:nval-1,m,k+1)=imaginary(zamp) & endif else begin $
readf,lu,amp & ampl(0:nval-1,m,k)=amp & endelse&endfor&endfor

;...change colons in tag into underscores
tagsplit=str_sep(tag,':')
if strlen(tagsplit(0)) eq 3 then tagsplit(0)='0'+tagsplit(0)
tag=tagsplit(0)+'_'+tagsplit(1)+'_'+tagsplit(2) & tag=strmid(tag,0,10)

;...make output file name
ofname=name+'_'+strcompress(tag,/remove_all)

;...close input file
close,lu & free_lun,lu

;... form date and time for lf file output
date=float(strmid(tag,0,4)) & ihr=fix(strmid(tag,5,2))
imin=fix(strmid(tag,8,2)) & time=100*long(100*ihr+imin)
;END RDKRDSC.M


;...
;CASCDWNS.M
;...initialization
i=meshb & mx=mxsh(meshb-1) & nx=nxsh(meshb-1) & mnoxo=(mx+3)*(nx+3)
ains=ampl(0:mnoxo-1,meshb-1,lv) & ains=reform(ains,mx+3,nx+3)
m1sb=1 & n1sb=1 & mxxsb=mx+1 & nxxsb=nx+1

;cascade all available meshes
while i gt 1 do begin i=i-1 & asup=ains &$
mx=mxsh(i-1) & nx=nxsh(i-1) & mnoxi=(mx+3)*(nx+3) &$
asub=ampl(0:mnoxi-1,i-1,lv) & asub=reform(asub,mx+3,nx+3) &$
m1sb=m1sb+m1sbsh(i)-1 & n1sb=n1sb+n1sbsh(i)-1 &$
mxxsb=mxxsb+mxxsbsh(i)-mxsh(i)-1 & nxxsb=nxxsb+nxxsbsh(i)-nxsh(i)-1 &$
INSERT,asup,asub,ains,m1sb,mxxsb,n1sb,nxxsb & endwhile
ADOUBLE,ains,zacde & if meshb eq 1 then begin $ 
ADOUBLE,zacde,ains & zacde=ains &endif
;END CASCDWNS.M


;...
;XTRCSCDAS.M
;extract cascaded amplitudes
i=meshb-2 &for k=1,i do begin $ 
THINS,zacde,zacdet & zacde=zacdet &endfor

;obtain mesoscale field values from cascaded amplitudes
ATOF,zacde,fzcsc
info=size(fzcsc) & mxx=info(1) & nxx=info(2)
mde=indgen(mxx) & nde=indgen(nxx)
xl=x1sh(meshb-1)/1000. & yb=y1sh(meshb-1)/1000.
dxyk=.001*(xxsh(meshb-1)-x1sh(meshb-1))/(mxx-1)
xkilo=xl+dxyk*mde & ykilo=yb+dxyk*nde
ic=where(abs(xkilo) eq min(abs(xkilo))) & ic=ic(0)
jc=where(abs(ykilo) eq min(abs(ykilo))) & jc=jc(0)
xmkm=xkilo-xkilo(ic) & ynkm=ykilo-ykilo(jc)
xyx=min([abs(min(xmkm)),max(xmkm),abs(min(ynkm)),max(ynkm)])
mnx=fix(round(xyx/dxyk)) 
ma=ic-mnx & mb=ic+2+mnx & na=jc-mnx & nb=jc+2+mnx

;generate final mesoscale amplitudes, wind components and coordinates
zacde=zacde(ma:mb,na:nb) & ATOF,zacde,fzcs
xmkm=xmkm(ic-mnx:ic+mnx) & ynkm=ynkm(jc-mnx:jc+mnx)
xwst=1000*xmkm(0) & ysth=1000*ynkm(0) & dxy=1000*dxyk
zo=complex(xkilo(ic),ykilo(jc))
;END XTRCSCDAS.M


;...
;CTRLVLS.M

levelsa=5+indgen(25)
levelsb=900+5*indgen(25);
levelsc=25+5*indgen(21)
levelsd=2.5*indgen(25)
levelse=100*(round(min(fzcs))/100)+50*indgen(26)
name='pressure'
flaga=strpos(name,'temp') & flagb=strpos(name,'TEMP')
if flaga ne -1 or flagb ne -1 then begin $
levelsctr=levelsa & sclf=5*fzcs &endif

flaga=strpos(name,'pressure') & flagb=strpos(name,'PRESSURE')
if flaga ne -1 or flagb ne -1 then begin $
levelsctr=levelsb & sclf=fzcs-900 &endif
;levelsctr=levelsb & sclf=fzcs &endif

flaga=strpos(name,'humidity') & flagb=strpos(name,'HUMIDITY')
if flaga ne -1 or flagb ne -1 then begin $
levelsctr=levelsc & sclf=fzcs &endif

flaga=strpos(name,'speed') & flagb=strpos(name,'SPEED')
if flaga ne -1 or flagb ne -1 then begin $
levelsctr=levelsd & sclf=2*fzcs &endif

flaga=strpos(name,'geopht') & flagb=strpos(name,'GEOPHT')
if flaga ne -1 or flagb ne -1 then begin $
levelsctr=levelse & sclf=(fzcs-levelsctr(0))/10 &endif
;CTRLVLS.M


;...
;GRAFIX.M 

;...initialization
!x.margin=[5,1] & !y.margin=[3,3]
!x.style=1 &!y.style=1
XYTOLL,1000*xmkm,1000*ynkm,elon,nlat,elo,gglo
!x.range=[elo-3,elo+3] &!y.range=[gglo-3,gglo+3]

;...contour scalar field
CONTOUR,sclf,elon,nlat,levels=levels,c_colors=colors,/fill,c_charsize=1.0
CONTOUR,fzcs,elon,nlat,levels=levelsctr,/overplot,/follow,thick=2
OPLOT,[elo,elo],[gglo-3,gglo+3],linestyle=3,thick=2
OPLOT,[elo-3,elo+3],[gglo,gglo],linestyle=3,thick=2

;...add time
sign=''
XYOUTS,elo-3,gglo-3,sign,charthick=1,charsize=1.20
device,/close
;GRAFIX.M


exit
;SCALAR.M
